$fn = 64;
Width = 160;
Length = 130;
Height = 4;
ph = 90 - Height;

module hexagon(size, height) {
  boxWidth = size / sqrt(3);
  for (r = [-60, 0, 60]) rotate([0,0,r]) cube([boxWidth, size, height], true);
}

module pilar(ph) {
  difference() {
    hexagon(11, ph);
    //translate([0, disp, 0])
    cylinder(d = 3.4, h = ph + 1, center = true, $fn = 64);
  }
}


difference() {
    union() { 
      cube(size = [Width,Length,Height], center = true);
      
      // power support
      translate([38, 0, -Height/2]) 
        cylinder(d = 5, h = 8, center = true);
      translate([56, 0, -Height/2]) 
        cylinder(d = 5, h = 8, center = true);  
      translate([38, -40, -Height/2]) 
        cylinder(d = 5, h = 8, center = true);
      translate([56, -40, -Height/2]) 
        cylinder(d = 5, h = 8, center = true);   
  
      //Arduino
      rotate([0,0,-90])
        union(){  
          translate([50, -12, -Height/2]) 
            cylinder(d = 5, h = 8, center = true);
          translate([50, -40, -Height/2]) 
            cylinder(d = 5, h = 8, center = true);      
          translate([0, -55, -Height/2]) 
            cylinder(d = 5, h = 8, center = true);      
          translate([0, -7, -Height/2]) 
            cylinder(d = 5, h = 8, center = true);     
        }    
        
      // batery 
      translate([0,40,0])
          union(){
            translate([58, 7, -10]) 
              cylinder(d = 5, h = 20, center = true);
            translate([58, -13, -10]) 
              cylinder(d = 5, h = 20, center = true);
            translate([-58, 7, -10]) 
              cylinder(d = 5, h = 20, center = true);
            translate([-58, -13, -10]) 
              cylinder(d = 5, h = 20, center = true);
          } 

      // axis support    
      translate([Width/2 - 5, -(Length/2 - 50), -30/2 + Height/2]) 
        cube(size = [10,30,30], center = true);
      translate([-(Width/2 - 5), -(Length/2 - 50), -30/2 + Height/2]) 
        cube(size = [10,30,30], center = true);          

      // pillars          
      translate([Width/2 - 10, Length/2 - 10, -ph/2 + Height/2]) 
        pilar(ph);    
      translate([-(Width/2 - 10), Length/2 - 10, -ph/2 + Height/2])    
        pilar(ph);      
      translate([Width/2 - 10, -(Length/2 - 10), -ph/2 + Height/2]) 
        pilar(ph);    
      translate([-(Width/2 - 10), -(Length/2 - 10), -ph/2 + Height/2])    
        pilar(ph);            
    }  

    // power support
    translate([38, 0, -Height/2-1]) 
      cylinder(d = 2, h = 9, center = true);
    translate([56, 0, -Height/2-1]) 
      cylinder(d = 2, h = 9, center = true);  
    translate([38, -40, -Height/2-1]) 
      cylinder(d = 2, h = 9, center = true);
    translate([56, -40, -Height/2-1]) 
      cylinder(d = 2, h = 9, center = true); 

    
    //Arduino
    rotate([0,0,-90])
     union(){  
        translate([50, -12, -Height/2-1]) 
          cylinder(d = 2, h = 9, center = true);
        translate([50, -40, -Height/2-1]) 
          cylinder(d = 2, h = 9, center = true);      
        translate([0, -55, -Height/2-1]) 
          cylinder(d = 2, h = 9, center = true);      
        translate([0, -7, -Height/2-1]) 
          cylinder(d = 2, h = 9, center = true);      
     }    
     
     
    // batery 
    translate([0,40,-2])
      union(){
        translate([58, 7, -10]) 
          cylinder(d = 2, h = 20, center = true);
        translate([58, -13, -10]) 
          cylinder(d = 2, h = 20, center = true);
        translate([-58, 7, -10]) 
          cylinder(d = 2, h = 20, center = true);
        translate([-58, -13, -10]) 
          cylinder(d = 2, h = 20, center = true);     
      } 
    
    // wheels axis
    translate([0, -15, -15 ]) 
      rotate([0,-90, 0])
        cylinder(d = 8.2, h = Width +0.1, center = true);
}    

