$fn = 64;
Width = 160;
Length = 280;
Height = 4;

nema17_d = 31;
nema17_corners = [
  [ nema17_d/2,  nema17_d/2],
  [-nema17_d/2,  nema17_d/2],
  [-nema17_d/2, -nema17_d/2],
  [ nema17_d/2, -nema17_d/2]
];

module place_things(pos_list) {
   for (t = pos_list) {  
     translate(t)
     children([0:1:$children-1]);
   }
}
 
translate([Width/2 - 5/2, 0, 4/2 + Height/2]) 
  cube(size = [5,Length,4], center = true);
translate([-(Width/2 - 5/2), 0, 4/2 + Height/2]) 
  cube(size = [5,Length,4], center = true);
difference() {
    cube(size = [Width,Length,Height], center = true);
    // On/Off
    translate([Width/2 - 20, -40, 0]) 
        cylinder(d = 15, h = 2*Height, center = true);
    // USB cable
    translate([-(Width/2 - 20), -40, 0]) 
        cylinder(d = 15, h = 2*Height, center = true);    
    // Rasp. Power 
    translate([Width/2 - 28, -(Length/2 - 48), 0]) 
        cylinder(d = 15, h = 2*Height, center = true);      
    // columns 
    translate([Width/2 - 10, -(Length/2 - 120), 0]) {
        cylinder(d = 4.5, h = 2*Height, center = true);
        cylinder(h=4.01, r1=2, r2=4, center=true);}
    translate([-(Width/2 - 10), -(Length/2 - 120), 0]) {
        cylinder(d = 4.5, h = 2*Height, center = true);
        cylinder(h=4.01, r1=2, r2=4, center=true);}
    translate([Width/2 - 10, -(Length/2 - 10), 0]) {
        cylinder(d = 4.5, h = 2*Height, center = true); 
        cylinder(h=4.01, r1=2, r2=4, center=true);}
    translate([-(Width/2 - 10), -(Length/2 - 10), 0]) {
        cylinder(d = 4.5, h = 2*Height, center = true); 
        cylinder(h=4.01, r1=2, r2=4, center=true);}
        
    // Raspberry     
    translate([75/2, -(Length/2 - 10), 0]) 
        cylinder(d = 4.5, h = 2*Height, center = true);           
    translate([-75/2, -(Length/2 - 10), 0]) 
        cylinder(d = 4.5, h = 2*Height, center = true);             
    translate([75/2, -(Length/2 - 10 - 75), 0]) 
        cylinder(d = 4.5, h = 2*Height, center = true);     
    translate([-75/2, -(Length/2 - 10 - 75), 0]) 
        cylinder(d = 4.5, h = 2*Height, center = true);  
        
    // Motor holes
    translate([0, Length/2 - 50 - 25, 0]) 
        place_things(nema17_corners) 
            cylinder(d = 3.5, h = 100, $fn = 32, center = true); 
    translate([0, Length/2 - 50 - 25, 0]) 
        cylinder(d = 24, h = 100, $fn = 32, center = true);          
        
}    



