module place_things(pos_list) {
   for (t = pos_list) {  
     translate(t)
     children([0:1:$children-1]);
   }
 }

nema17_d = 31;
nema17_w = 43;
wall_d = 5;
 
 nema17_corners = [
  [ nema17_d/2,  nema17_d/2],
  [-nema17_d/2,  nema17_d/2],
  [-nema17_d/2, -nema17_d/2],
  [ nema17_d/2, -nema17_d/2]
];

module motor_plate() {
  difference() { 
    union(){   
      cube([nema17_w, nema17_w, wall_d], center = true);
      
    }  
    // Motor support holes   
    place_things(nema17_corners)
    translate([0, 0 , 0]) cylinder(d = 3.5, h = 100, $fn = 32, center = true); 
    
    cylinder(d = 23, h = 100, $fn = 64, center = true); 
  }
}

head_height = 25;
head_d = 20;
head_bore =  5 + 0.6;
neck_h = 12 + 5;

module head(){
  
  difference () {
    union () { 
      
      translate([0, 0, 0])
      cylinder(d = head_d, h = head_height, center = true, $fn = 6);
    }
    // Center hole
    cylinder(d = head_bore, h = 2 * head_height, center = true, $fn = 64);

    
    // Screw 120º
    for(i = [0:2]) {
      rotate([0, 0, 0 + 120 * i])
      //translate([0, -6, width + 2 + neck_h/2 + 1])
      translate([0, 0, 0])
      rotate([90, 0, 0]) {
        translate([0, 0, 0])
        cylinder(d = 3.5, h = 140, center = false, $fn = 32);
      }
    }

  }
}


module head_rect(){
  
  difference () {
    union () { 
      
      translate([0, 0, 0])
      cube([nema17_w, head_d, head_height], center = true);
    }
    // Center hole
    cylinder(d = head_bore, h = 2 * head_height, center = true, $fn = 64);

    
    // Screw 90º
    for(i = [0:3]) {
      rotate([0, 0, 0 + 90 * i])
      //translate([0, -6, width + 2 + neck_h/2 + 1])
      translate([0, 0, 5])
      rotate([90, 0, 0]) {
        translate([0, 0, 0])
        cylinder(d = 3.5, h = 140, center = false, $fn = 32);
      }
    }

  }
}


motor_disp_h = 25;
motor_disp_v = 15;

module traction_stepper() {
  difference () {
    union () { 
      // Top Connection
      translate([0, 0, head_height/2])
        head_rect();
      
      translate([0, -wall_d/2 -7.5 +7/2, -wall_d/2 + 3.5])
        cube([nema17_w, 2 * motor_disp_h + wall_d - ((2 * motor_disp_h + wall_d)/2 - head_d/2 ) +2.5 -7, wall_d], center = true);

      translate([0, -(2 * motor_disp_h + wall_d)/2 +7, -motor_disp_v/2 - wall_d + 5])
        cube([nema17_w, wall_d, motor_disp_v + 1], center = true);
      
      // Nema 17 plate 
      translate([0, -motor_disp_h +7, -nema17_w/2 - wall_d - motor_disp_v + 5])
        rotate([-90, 0, 0])
          translate([0, 0, -wall_d/2])
            motor_plate();       
    }
  }
}


//motor_plate();
//head();

//rotate([0, 90, 0])
traction_stepper();
